/*    
    Copyright (C) 2006  Andrea Detti, Claudio Loreti, Remo Pomposini
    This file is part of "Obamp Proxy",

    "Obamp Proxy" is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    "Obamp Proxy" is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
*/

import java.util.Timer;
import java.util.TimerTask;


public class JoinReqTimer {
    
    Timer timer;
    Signalling agent;
    int count;
    
	
    public JoinReqTimer(Signalling agent_) {
	count = 0;
	agent = agent_;
        timer = new Timer();
        timer.schedule(new JoinReqTimerTask(), 
                1000,
                agent.req_interval);
	    
    }
    
    public void handle(){
                
    	if (agent.state.is_core){
            agent.state.request_number=0;
            agent.state.found_neighbour = false;
            agent.state.req_last_ttl=1;
            agent.state.req_timeout1 = System.currentTimeMillis() + agent.req_interval;
            //int a;
            //for (a=1; a<=agent.state.hello_max_ttl; a++){
            long short_hello_interval = 3*10*10*agent.state.hello_req_last_ttl;
                //agent.state.hello_req_last_ttl=a;
                //if (a==1){
            new ersTimer(agent, 1, 0, agent.state.req_last_ttl);                   
                //}else{
                    //new ersTimer(agent, short_hello_interval, a);
                //}
                
            //}
            //new ersTimer(agent);
            //agent.sendHello();
    	}
    }

    class JoinReqTimerTask extends TimerTask {
	
        public void run() {
            
            if (agent.neighbors.isEmpty()){
                handle();
            }else{
                timer.cancel();
            }
                
            
        }
    } 
} 