/*    
    Copyright (C) 2006  Andrea Detti, Claudio Loreti, Remo Pomposini
    This file is part of "Obamp Proxy",

    "Obamp Proxy" is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    "Obamp Proxy" is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
*/

import java.io.*;
import java.net.*;

import Multicast.*;
import prominence.msg.*;
import prominence.util.Queue; 

public class pktJoinAck {
	
	
	//packet variables: 18 Bytes
	protected byte MessageID;
	//protected byte SequenceNumber;	
	protected byte SourceIP;
	protected byte CoreAddress;
	protected InetAddress SourceIPAddress;	
	protected InetAddress DestinationIPAddress;
  	protected InetAddress IPCoreAddress;
  	protected byte[] address;
    protected int TTL;
 	//protected double DelayBudjet;
 	//protected byte ret;
 	
 	//complementary variables 
 	protected int sourcePort;  	  	
  	protected byte[] data;  
  	protected int destPort;
  	
  	public pktJoinAck(InetAddress address_) {
  	  	MessageID = 2;	
  	  	address = address_.getAddress();
  	}
  	
  	
  	public pktJoinAck(InetAddress SourceIPAddress_, InetAddress IPCoreAddress_, int TTL_) {
  		
		MessageID = 2;
		SourceIPAddress = SourceIPAddress_;
		IPCoreAddress = IPCoreAddress_;
		byte ind [] = SourceIPAddress.getAddress();
		 this.SourceIP = ind [3];
		 byte indC [] = IPCoreAddress.getAddress();
		 this.CoreAddress = indC [3];
 		
  		TTL = TTL_;
                
  		
  		  		  		
  	}
  	  	  	
  	  	
  	//it sets the packet by an input stream
  	public void SetpktJoinAck(DataInputStream qI){
  		
  		
		try{  		
		  		//settings variables		  		  		
		  		MessageID = qI.readByte();//2;
		  		SourceIP = qI.readByte();
		  		CoreAddress = qI.readByte();
		  		
		  		byte ind [] = new byte[4];
                ind[0] = address[0];
                ind[1] = address[1];
                ind[2] = address[2];
                ind[3] = SourceIP;
                this.SourceIPAddress = InetAddress.getByAddress(ind);
                byte indC [] = new byte[4];
                indC[0] = address[0];
                indC[1] = address[1];
                indC[2] = address[2];
                indC[3] = CoreAddress;
                this.IPCoreAddress = InetAddress.getByAddress(indC);
		  		
                TTL = qI.readInt();
		  		
		  		
  		 } catch (IOException ex) {
  			
  		}
  		return;
        
    }
  	
  	public byte[] GetpktJoinAck(){
  		
  		
  		try {  			
  			
  			  			
  			//byte[] SourceIP = SourceIPAddress.getAddress();
  			  			
  			ByteArrayOutputStream boStream = new ByteArrayOutputStream ();
        	DataOutputStream doStream = new DataOutputStream (boStream);
       		doStream.writeByte(MessageID);
       		doStream.writeByte(SourceIP);
       		doStream.writeByte(CoreAddress);
       		doStream.writeInt(TTL);
        	     	        	
        	data = boStream.toByteArray ();
        	
        } catch (IOException ex) {
           		ex.printStackTrace ();
        }
        
        return data;
        
    }
  		
}