/*    
    Copyright (C) 2006  Andrea Detti, Claudio Loreti, Remo Pomposini
    This file is part of "Obamp Proxy",

    "Obamp Proxy" is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    "Obamp Proxy" is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
    
*/

import java.io.*;
import java.net.*;

import Multicast.*;
import prominence.msg.*;
public class pktTreeCreateConf {
	
	//packet variables: 3 Bytes
    protected byte MessageID;
    protected byte SourceIP;
    protected byte CoreAddress;
	protected byte SequenceNumber;	
        
	//complementary variables 
    protected InetAddress SourceIPAddress;	
	protected InetAddress MulticastIPAddress;
  	protected InetAddress IPCoreAddress;
  	protected byte[] address;
 	protected int port;  	  	
  	protected byte[] data;

  	
  	public pktTreeCreateConf(InetAddress address_) {
  	  	MessageID = 9;	
  	  	address = address_.getAddress();
  	}
  	
  	public pktTreeCreateConf(byte SequenceNumber_, InetAddress SourceIPAddress_, InetAddress IPCoreAddress_) {
  		
  		MessageID = 9;
                
                
  		SequenceNumber = SequenceNumber_;
  		SourceIPAddress = SourceIPAddress_;
  		IPCoreAddress = IPCoreAddress_;
  		
                
                byte ind [] = SourceIPAddress.getAddress();
                this.SourceIP = ind [3];
                byte indC [] = IPCoreAddress.getAddress();
                this.CoreAddress = indC [3];
  	}
  	
  	//it sets the packet by an input stream
  	public void SetpktTreeCreateConf(DataInputStream qI){
  		
  		
		try{
                    
                    //settings variables		  		  		
                    MessageID = qI.readByte();//9;
                    SourceIP = qI.readByte();
                    CoreAddress = qI.readByte();
                    SequenceNumber = qI.readByte();
                                                    
                    byte ind [] = new byte[4];
                    ind[0] = address[0];
                    ind[1] = address[1];
                    ind[2] = address[2];
                    ind[3] = SourceIP;
                    this.SourceIPAddress = InetAddress.getByAddress(ind);
                    byte indC [] = new byte[4];
                    indC[0] = address[0];
                    indC[1] = address[1];
                    indC[2] = address[2];
                    indC[3] = CoreAddress;
                    this.IPCoreAddress = InetAddress.getByAddress(indC);
                   	  				  		
		  				  		
  		 } catch (IOException ex) {
  			
  		}
  		return;
        
    }
    
    public byte[] GetpktTreeCreateConf(){
  		
  		
  		try {
                    
                    ByteArrayOutputStream boStream = new ByteArrayOutputStream ();
                    DataOutputStream doStream = new DataOutputStream (boStream);
                    doStream.writeByte(MessageID);
                    doStream.writeByte(SourceIP);
                    doStream.writeByte(CoreAddress);
                    doStream.writeByte(SequenceNumber);       
                    
                    data = boStream.toByteArray ();
  			
        	
        } catch (IOException ex) {
           		ex.printStackTrace ();
        }
        
        return data;
        
    }
      	  	  		
}